<?php
if ($_POST['pu_element'] != "profileurl")
	die('Direct Access to this location is not allowed.');

// Set flag that this is a parent file
define( '_VALID_MOS', 1 );
/* ## Emulating Joomla environment */
require_once( '../../../../../configuration.php' );
//require_once( $mosConfig_absolute_path.'/globals.php' );
require_once( $mosConfig_absolute_path.'/includes/joomla.php' );
// mainframe is an API workhorse, lots of 'core' interaction routines
$mainframe = new mosMainFrame( $database, $option, '.' );
$mainframe->initSession();
// get the information about the current user from the sessions table
$my = $mainframe->getUser();
$userid = $_POST['userid'];
$new_profileName = trim($_POST['pu_newName']);
# Get params
$tabparam = getPluginParams();
// Assign params
$raw_arrs = explode("<br />",$tabparam['puDisallowed']);
$disallowedNames = array();
foreach ($raw_arrs as $raw_arr) {
	array_push($disallowedNames, trim($raw_arr));
}
$profileURL = $mosConfig_live_site.'/';
$database->setQuery( "SELECT cb.user_id, cb.pu_profilename, jos.username " .
					"FROM #__comprofiler cb " .
					"LEFT JOIN #__users jos ON cb.user_id = jos.id " .
					"WHERE cb.user_id=".$userid );
$row = null;
$database->loadObject($row);
if ($row->pu_profilename && $row->pu_profilename != "")
	$profileName = $row->pu_profilename;
else
	$profileName = $row->username;

//start of validations
$reply = null;
$span_html = '<span style="font-size:80%;color:';
$reply .= $span_html;
if (strlen($new_profileName) < 4 || strlen($new_profileName) > 16)
	$reply .= 'red">Profile names must contain between 4 and 16 characters.';
elseif (!eregi('^([a-z]{1})+([_a-z0-9-]+)*$', $new_profileName))
	$reply .= 'red">Profile names can only contain a-z and 0-9, and the first character must be a letter.';
else {
	foreach ($disallowedNames as $disallowedName) {
		if ($disallowedName == $new_profileName) {
			$reply .= 'red">&quot;'.$new_profileName.'&quot; is not allowed.';
			$valid = false;
			break;
		}
	}
	if ($reply == $span_html) {
		if ($profileName == $new_profileName) {
			$reply .= 'red">Your profile name is already &quot;'.$new_profileName.'&quot;';
		}
		else {
			$database->setQuery( "SELECT cb.pu_profilename, jos.username " .
								"FROM #__comprofiler cb " .
								"LEFT JOIN #__users jos ON cb.user_id = jos.id " .
								"WHERE 1" );
			$xrows = $database->loadObjectList();
			$valid = true;
			foreach ($xrows as $xrow) {
				if ($row->username != $new_profileName && ($xrow->pu_profilename == $new_profileName || $xrow->username == $new_profileName)) {
					$reply .= 'red">&quot;'.$new_profileName.'&quot; is already taken.';
					$valid = false;
					break;
				}
			}
		}
	}
	if ($reply == $span_html) {
		$database->setQuery( "UPDATE #__comprofiler SET `pu_profilename` = '$new_profileName' WHERE `user_id`=".$userid );
		$database->query();
		$reply .= 'green">New Profile URL set!';
		$profileName = $new_profileName;
	}
}
	
$reply .= '</span>';

$profileURL .= $profileName;
$return = null;
$return .= '<table cellpadding="5" cellspacing="0" border="0" width="100%" class="cbStatusList"><tr><td  class="sectiontableentry1" width="100" style="font-weight:bold;">Profile URL</td>';
$return .= '<td class="sectiontableentry1"><a href="'.$profileURL.'" title="'.$row->username.'\'s URL">'.$profileURL.'</a>';
if ($my->id == $userid) {
	$return .= ' [<a href="javascript:void(0);" title="Edit your profile name" onClick="pu_editName(\''.$mosConfig_live_site.'\',\''.$profileName.'\');">edit url</a>]';
}
$return .= '</td></tr>';
$return .= '<tr><td>&nbsp;</td><td>'.$reply.'</td></tr></table>';

echo $return;

/**
 * Extract plugin's parameters from #__comprofiler_plugin
 * @return array. key=param name, value=param value
 */
function getPluginParams() {
	global $database;
	$param = array();
	$database->setQuery( "SELECT `params` FROM #__comprofiler_plugin WHERE element='profileurl'" );
	$param_string = $database->loadResult();
	$parameters = explode("\n", $param_string);
	foreach ($parameters as $parameter) {
		$split = explode("=", $parameter, 2);
		$param[$split[0]] = $split[1];
	}
	return $param;
}

?>
